package typing;
import org.jcsp.lang.*;
import newjcircusutil.multisync.GeneralChannel;
import newjcircusutil.multisync.ChannelInfo;
public class GPSE {
	public static int indexOfEndPart (int line, int pos, int chanDim, int [] typesize) {
		return (line / (multiplicand (pos + 1, chanDim - 1, typesize))) % (typesize.length <= pos? 1 : typesize [pos]);
	}
	private static int multiplicand (int x, int y, int [] typesize) {
		int result = 1;
		for (int i = x; i <= y; i++) {
			result = result * typesize [i];
		}
		return result;
	}
	public static int numberOfEnds (int [] typesizes) {
		int total = 1;
		for (int i = 0/*1*/; i </*=*/ typesizes.length; i++) {
			total = total * typesizes [i];
		}
		return total;
	}
	public static GeneralChannel  getProcessSyncEnds (int x, GeneralChannel gc, int [] typesizes) {
		GeneralChannel b = new GeneralChannel (gc.getChannelInfo(), gc.getChannelInfo().getArray(x));
		b.setProcId (x);
		b.setEnd (gc.getEndsFromProcess (gc.getChannelInfo().getArray (x)));
		return b;
	}
	public static void resetEnds (GeneralChannel gc, int [] typesizes) {
		gc.resetEnds ();
	}
	public static GeneralChannel [] getProcessSyncEnds (int x, GeneralChannel [] gc, int [] typesizes) {
		GeneralChannel [] b = new GeneralChannel [typesizes [0]];
		for (int i = 0; i < numberOfEnds(typesizes); i++) {
			b [indexOfEndPart (i, 0, typesizes.length, typesizes)] = new GeneralChannel (gc[0].getChannelInfo(), gc[0].getChannelInfo().getArray(x));
			b [indexOfEndPart (i, 0, typesizes.length, typesizes)].setProcId (x);
			b [indexOfEndPart (i, 0, typesizes.length, typesizes)].setEnd (gc [indexOfEndPart (i, 0, typesizes.length, typesizes)].getEndsFromProcess (gc[0].getChannelInfo().getArray (x)));
		}
		return b;
	}
	public static void resetEnds (GeneralChannel [] gc, int [] typesizes) {
		for (int i = 0; i < numberOfEnds(typesizes); i++) {
			gc [indexOfEndPart (i, 0, typesizes.length, typesizes)].resetEnds ();
		}
	}
	public static GeneralChannel [][] getProcessSyncEnds (int x, GeneralChannel [][] gc, int [] typesizes) {
		GeneralChannel [][] b = new GeneralChannel [typesizes [0]][typesizes [1]];
		for (int i = 0; i < numberOfEnds(typesizes); i++) {
			b [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)] = new GeneralChannel (gc[0][0].getChannelInfo(), gc[0][0].getChannelInfo().getArray(x));
			b [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)].setProcId (x);
			b [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)].setEnd (gc [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)].getEndsFromProcess (gc[0][0].getChannelInfo().getArray (x)));
		}
		return b;
	}
	public static void resetEnds (GeneralChannel [][] gc, int [] typesizes) {
		for (int i = 0; i < numberOfEnds(typesizes); i++) {
			gc [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)].resetEnds ();
		}
	}
	public static GeneralChannel [][][] getProcessSyncEnds (int x, GeneralChannel [][][] gc, int [] typesizes) {
		GeneralChannel [][][] b = new GeneralChannel [typesizes [0]][typesizes [1]][typesizes [2]];
		for (int i = 0; i < numberOfEnds(typesizes); i++) {
			b [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)][indexOfEndPart (i, 2, typesizes.length, typesizes)] = new GeneralChannel (gc[0][0][0].getChannelInfo(), gc[0][0][0].getChannelInfo().getArray(x));
			b [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)][indexOfEndPart (i, 2, typesizes.length, typesizes)].setProcId (x);
			b [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)][indexOfEndPart (i, 2, typesizes.length, typesizes)].setEnd (gc [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)][indexOfEndPart (i, 2, typesizes.length, typesizes)].getEndsFromProcess (gc[0][0][0].getChannelInfo().getArray (x)));
		}
		return b;
	}
	public static void resetEnds (GeneralChannel [][][] gc, int [] typesizes) {
		for (int i = 0; i < numberOfEnds(typesizes); i++) {
			gc [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)][indexOfEndPart (i, 2, typesizes.length, typesizes)].resetEnds ();
		}
	}
	public static GeneralChannel [][][][] getProcessSyncEnds (int x, GeneralChannel [][][][] gc, int [] typesizes) {
		GeneralChannel [][][][] b = new GeneralChannel [typesizes [0]][typesizes [1]][typesizes [2]][typesizes [3]];
		for (int i = 0; i < numberOfEnds(typesizes); i++) {
			b [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)][indexOfEndPart (i, 2, typesizes.length, typesizes)][indexOfEndPart (i, 3, typesizes.length, typesizes)] = new GeneralChannel (gc[0][0][0][0].getChannelInfo(), gc[0][0][0][0].getChannelInfo().getArray(x));
			b [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)][indexOfEndPart (i, 2, typesizes.length, typesizes)][indexOfEndPart (i, 3, typesizes.length, typesizes)].setProcId (x);
			b [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)][indexOfEndPart (i, 2, typesizes.length, typesizes)][indexOfEndPart (i, 3, typesizes.length, typesizes)].setEnd (gc [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)][indexOfEndPart (i, 2, typesizes.length, typesizes)][indexOfEndPart (i, 3, typesizes.length, typesizes)].getEndsFromProcess (gc[0][0][0][0].getChannelInfo().getArray (x)));
		}
		return b;
	}
	public static void resetEnds (GeneralChannel [][][][] gc, int [] typesizes) {
		for (int i = 0; i < numberOfEnds(typesizes); i++) {
			gc [indexOfEndPart (i, 0, typesizes.length, typesizes)][indexOfEndPart (i, 1, typesizes.length, typesizes)][indexOfEndPart (i, 2, typesizes.length, typesizes)][indexOfEndPart (i, 3, typesizes.length, typesizes)].resetEnds ();
		}
	}
}
